diff --git a/power.sh b/power.sh
index f14f7b4..ceba154 100755
--- a/power.sh
+++ b/power.sh
@@ -9,22 +9,27 @@ getState;
 
 checkStateChanged;
 
-for x in /proc/acpi/ac_adapter/*; do
-    if [ -d "$x" ] ; then    
-	    grep -q off-line $x/state
+ac_adapters() {
+    for x in /sys/class/power_supply/*; do
+	read type <$x/type
+	test "$type" = "Mains" && echo $x
+    done
+}
 
-	    if [ $? = 0 ] && [ x$1 != xstop ]; then	
-		for SCRIPT in /etc/acpi/battery.d/*.sh; do
-		    if [ -f $SCRIPT ] ; then
-		        . $SCRIPT
-		    fi
-		done
-	    else
-		for SCRIPT in /etc/acpi/ac.d/*.sh; do
-		    if [ -f $SCRIPT ] ; then
-		        . $SCRIPT
-		    fi
-		done
+for x in $(ac_adapters); do
+    grep -q 0 $x/online
+
+    if [ $? = 0 ] && [ x$1 != xstop ]; then
+	for SCRIPT in /etc/acpi/battery.d/*.sh; do
+	    if [ -f $SCRIPT ] ; then
+		. $SCRIPT
+	    fi
+	done
+    else
+	for SCRIPT in /etc/acpi/ac.d/*.sh; do
+	    if [ -f $SCRIPT ] ; then
+		. $SCRIPT
 	    fi
+	done
     fi
 done
